// Bank Brick

// Brick Data
datablock fxDtsBrickData(ATMBrickData : brick2x2RampPrintData)
{
	category = "RP";
	subcategory = "Event bricks";
	
	uiName = "ATM Brick";
	
	specialBrickType = "";
	
	cost = 5000;
	
	isInfoBrick = 1;
	adminOnly = 0;
};

// Brick functions

// Activate data
function ATMBrickData::Activate(%datablock, %client)
{
	messageClient(%client, '', "\c3ATM");
	messageClient(%client, '', '\c6You have \c3%1\c6 in bank account.', prepareDisplayMoney(getMetricPrefix(%client.RPData.value["bank"])));
	messageClient(%client, '', '\c31. \c6Withdraw %1', $RP::pref::moneyName);
	%client.activateDatablock = %datablock;
	%client.activateState = 0;
	return true;
}

// Handle data
function ATMBrickData::parseData(%datablock, %client, %text)
{
	%client.ThrowLastActive();
	
	%number = atoi(%text);
	switch (%client.activateState)
	{
		// Start
		case 0:
			switch (%number)
			{
				// Withdraw
				case 1:
					messageClient(%client, '', '\c6Insert the amount of \c3%1\c6 to be withdrawn.', $RP::pref::moneyName);
					%client.activateState = 1.1;
				// Invalid
				default:
					%client.stopActivate();
					return false;
			}
		// Withdraw money
		case 1.1:
			%client.stopActivate();
			if (%number <= 0)
				return false;
			
			%number = (%number > %client.RPData.value["bank"]) ? %client.RPData.value["bank"] : %number;
			messageClient(%client, '', '\c6You have withdrawn \c3%1\c6.', prepareDisplayMoney(getMetricPrefix(%number)));
			%client.RPData.value["bank"] -= %number;
			%client.RPData.value["money"] += %number;
		// Invalid
		default:
			%client.stopActivate();
			return false;
	}
	return true;
}